`include "state_d.v"
module exfetch(clk,rst_n,run,halt);

  input clk,rst_n,run,halt;
  wire [1:0] cs;
  wire [11:0] pcout;
  wire [15:0] irout,ramout,dbus;
  reg [11:0] abus;

  state state0(.clk(clk),.rst_n(rst_n),.run(run),.halt(halt),.q(cs));
  counter #(12) pc0(.clk(clk),.rst_n(rst_n),.load(1'b0),.inc(cs==`FETCH),.q(pcout));
  counter #(16) ir0(.clk(clk),.rst_n(rst_n),.load(cs==`FETCH),.inc(1'b0),.d(ramout),.q(irout));
  ram ram0(.clk(clk),.load(cs==`EXEC),.addr(abus),.d(dbus),.q(ramout));

  always @(cs,pcout,irout)
    if(cs==`FETCH) abus=pcout;
    else if(cs==`EXEC) abus={4'h0,irout[15:8]};
    else abus=12'hXXX;

  assign dbus=(cs==`FETCH)?ramout:16'hZZZZ;
  assign dbus=(cs==`EXEC)?{8'h00,irout[7:0]}:16'hZZZZ;

endmodule
