`include "state_d.v"
module formula(clk,rst_n,run,qtop);

  input clk,rst_n,run;
  output [15:0] qtop;
  wire [1:0] cs;
  wire [11:0] pcout;
  wire [15:0] ramout,irout;
  wire num,op;

  state state0(.clk(clk),.rst_n(rst_n),.run(run),.halt(1'b0),.q(cs));
  counter #(12) pc0(.clk(clk),.rst_n(rst_n),.load(1'b0),.inc(cs==`FETCH),.q(pcout));
  counter #(16) ir0(.clk(clk),.rst_n(rst_n),.load(cs==`FETCH),.inc(1'b0),.d(ramout),.q(irout));
  ram ram0(.clk(clk),.load(1'b0),.addr(pcout),.q(ramout));
  opstack opstack0(.clk(clk),.num(num),.op(op),.x(irout),.qtop(qtop));

  assign num=(cs==`EXEC)&&~irout[15];
  assign op=(cs==`EXEC)&&irout[15];

endmodule

