module ram(clk,load,addr,d,q);
  parameter N=16,M=12;

  input clk, load;
  input [M-1:0] addr;
  input [N-1:0] d;
  output [N-1:0] q;
  reg [N-1:0] mem [0:2**M-1];

  assign q = mem[addr];

  always @(posedge clk) if(load) mem[addr]<=d;

  initial begin
    mem[12'h000] = 16'h200A; //  L1: PUSH n
    mem[12'h001] = 16'h6003; //      JNZ L2
    mem[12'h002] = 16'h0000; //      HALT
    mem[12'h003] = 16'h200A; //  L2: PUSH n
    mem[12'h004] = 16'hE000; //      OUT
    mem[12'h005] = 16'h200A; //      PUSH n
    mem[12'h006] = 16'h1001; //      PUSHI 1
    mem[12'h007] = 16'hF001; //      SUB
    mem[12'h008] = 16'h300A; //      POP n
    mem[12'h009] = 16'h4000; //      JMP L1
    mem[12'h00A] = 16'h0009; //  n:  9
  end

endmodule
