%{
#include <stdio.h>
extern int yylex();
int yyerror(const char *s);
%}
%union {int n; char *s;}
%token <n> NUM
%token <s> NAME
%left OR
%left AND
%left '|'
%left '^'
%left '&'
%left EQ NE
%left GE LE '<' '>'
%left SHL SHR
%left '+' '-'
%left '*'
%right '!' '~' NEG
%%
stmts:
|stmts assign
;
assign: NAME '=' expr ';' {printf("\tPOP %s\n",$1);free($1);}
;
expr: NAME {printf("\tPUSH %s\n",$1);free($1);}
| NUM {printf("\tPUSHI %d\n",$1);}
| '!' expr {printf("\tNOT\n");}
| '~' expr {printf("\tBNOT\n");}
| '-' expr %prec NEG {printf("\tNEG\n");}
| expr '+' expr {printf("\tADD\n");}
| expr '-' expr {printf("\tSUB\n");}
| expr '*' expr {printf("\tMUL\n");}
| expr AND expr {printf("\tAND\n");}
| expr OR expr {printf("\tOR\n");}
| expr '&' expr {printf("\tBAND\n");}
| expr '|' expr {printf("\tBOR\n");}
| expr '^' expr {printf("\tBXOR\n");}
| expr SHL expr {printf("\tSHL\n");}
| expr SHR expr {printf("\tSHR\n");}
| expr EQ expr {printf("\tEQ\n");}
| expr NE expr {printf("\tNE\n");}
| expr GE expr {printf("\tGE\n");}
| expr LE expr {printf("\tLE\n");}
| expr '<' expr {printf("\tLT\n");}
| expr '>' expr {printf("\tGT\n");}
| '(' expr ')'
;
%%
int yyerror(const char *s){printf("%s\n",s);}
int main(){return(yyparse());}
